////// Autonomated Velocity Transmssion for a Bicycle of 9 gears/////

#include <p18f4550.h>

//////////////////////////////////////////// Pragmacode /////////////////////////////////////////////////
#pragma config PBADEN=OFF

//////////////////////////////////////////// Variables /////////////////////////////////////////////////
unsigned int sensors=0;              // Counter of the sensor in the star
unsigned int sensorw=0;              // Counter of the sensor in the wheel
unsigned int rpms=0;                 // Rpms of the star
unsigned int rpmw=0;                 // Rpms of the wheel 
unsigned int velw;  

//////////////////////////////////////////// Interruption functions //////////////////////////////////////////////////
void Llanta (void);                  //Wheel 
void Estrella (void);                //Star 


/////////////////////////////////////// High Priority Interruptions /////////////////////////////////////////////////

#pragma code high_vector=0x08 
void high_interrupt (void) 
{   
	INTCONbits.RBIF=0; 
     _asm nop _endasm 

}

//////////////////////////////////////////// Low Priority Interruptions //////////////////////////////////////////////////

#pragma code low_vector=0x18
void low_interrupt (void)
{
    if(INTCON3bits.INT1IF==1){      //interruption for INT1 on rising edge
         _asm goto Llanta _endasm   //Wheel
    } 

    if(INTCONbits.RBIF==1) {        //Interruption for change on RB port change
        _asm goto Estrella _endasm  //Star
    } 

}


#pragma code                
#pragma interruptlow Llanta 
void Llanta (void)              //Counts when the hall sensor of the wheel is activated
{    
    INTCON3bits.INT1IF=0;           //Turn off flag
    sensorw++;                    //add 
}


#pragma interruptlow Estrella           //Counts when the hall sensor of the star is activated
void Estrella (void) 
{   
    INTCONbits.RBIF=0;                  //Turn off flag 
    if(PORTBbits.RB4 == 1){       
        sensors++;                      //Add
    }   
}

////////////////////////////////////////////// Main program /////////////////////////////////////////////////////////////////////
void main (void) 
{ 
    unsigned int temp16;    
    OSCCON=0b01100000;          //Oscillator 4 MHz

    //Pins Configuration
    TRISBbits.RB0=1;            //input sensor wheel
	TRISBbits.RB1=1;            //input sensor wheel
    TRISBbits.RB4=1;            //input sensor star
    TRISB=0xFF;                 //All as inputs 

    T1CON=0b01000001;           // Oscillator 4 MHz, timer 1        
    ///////////////////////// Priorities //////////////////////////////// 

    RCONbits.IPEN=1;            //Enable priority levels 
    INTCON=0b11111000;          //Enable high, low interrupt, INT0 and TMR0overflow and RB port change interrupt 
    INTCON2=0b01110000;         //Pull up enabled, interrupt on rising edge, and low priority on rb change and tmr0 interrupt
    INTCON3=0b00011000;         //low priority interruption, and enables INT1 & INT2 interruptions. 
    ADCON1=0x0F;                //digital input
	INTCONbits.INT0IF == 0;		// Initialize flag of interrupt
	INTCON3bits.INT1IF == 0;	// Initialize flag of interrupt
	INTCON3bits.INT2IF == 0;	// Initialize flag of interrupt
    PORTBbits.RB0=0;			// Initialize RB0 in 0
	PORTBbits.RB1=0;			// Initialize RB1 in 0
	PORTBbits.RB2=0;			// Initialize RB2 in 0
	do{ 
      // INTCON3bits.INT1IF=1;   // This was made to make a test. i put this as one, the interruption works and it goes where it should go. 
    }
    while(1); 
}
